const dbConnection = require("../db/connection");
const jwt = require("jsonwebtoken");
const tokenAuth = require("../middleware/token.auth");
const { server, storage, logger_data, logger_msg } = require('../config/utils');
require("./globalfuntions.controller");

loginController = {};

// * Carga la página del controlador.
loginController.loadpage = (req, res) => {
	globalFunctions.logger(logger_data(req), 'info', logger_msg.loading);
	res.send("API login");
};

let msgLog = [];

// * Autorizacion de usuario
loginController.login_post = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	// * Se almacena el usuario y la contraseña en la constante 'user'

	const user = req.body;

	if (!user) {
		globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
		res.status(404).send({ message: "No hay información a solicitar." });
	}

	if (user) {
		storage.username = user.username;
		globalFunctions.logger(logger_data(req), 'info', logger_msg.info);
		// location url quemada

		/*
			todo: definir en variables de entorno en produccion! la url para que el siguiente metodo sea de la siguiente manera
			const url = process.env.URL || server.TEST.instancias[0].url;
			globalFunctions.location_url(url);
			!por mientras se quedara como abajo 
		*/
		const locationNew = globalFunctions.location_url(server.PROD_2.instancias[0].url);
		globalFunctions.logger(logger_data(req), 'info', `${logger_msg.ruta} ${locationNew}`);

		const queryInstancia =
			"SELECT id, status FROM connections WHERE url = ?";
		dbConnection.connectionInstancias.query(
			queryInstancia,
			[locationNew],
			(error, response) => {
				if (error) {
					globalFunctions.logger(logger_data(req), 'error', `${logger_msg.consulta.error} de instancia: ${error}`);
				}
				if (response) {
					globalFunctions.logger(logger_data(req), 'info', `${logger_msg.consulta.response} de instancia.`);
					if (response.length == 0) {
						globalFunctions.logger(logger_data(req), 'error', logger_msg.servicio);
						const status = globalFunctions.statusMsg(3);
						res.status(200).send(status);
					} else if (response[0].status == 1) {
						const SP_LoginGetIds =
							"CALL SP_LoginGetIds (?, ?, @userId, @userRoleId, @userEmpresasId); " +
							"SELECT @userId AS userId; " +
							"SELECT @userRoleId AS userRoleId; " +
							"SELECT @userEmpresasId AS userEmpresasId;" +
							"SELECT userName FROM usuarios WHERE id=@userId";

						// ? Creacion de JWT?
						dbConnection.connectionDB.query(
							SP_LoginGetIds,
							[user.username, user.password],
							(error, response, result) => {
								if (error) {
									globalFunctions.logger(logger_data(req), 'error', `${logger_msg.consulta.error} SP_LoginGetIds: ${error}`);
									globalFunctions.logger(logger_data(req), 'error', logger_msg.consulta.busquedaUsuarioError);
									res.status(404).send({ message: "Error al buscar el usuario." });
								} else {
									globalFunctions.logger(logger_data(req), 'info', `${logger_msg.consulta.response} de usuario`);

									const userId = response[1][0].userId,
										userRoleId = response[2][0].userRoleId,
										userEmpresasId = response[3][0].userEmpresasId,
										userName = response[4][0].userName;

									if (userId == null || userRoleId == null || userEmpresasId == null) {
										globalFunctions.logger(logger_data(req), 'error', logger_msg.consulta.usuarioNoEncontrado);
										res.send({ message: "No se pudo encontrar el usuario." });
									}

									if (userId > 0) {
										// ! creacion de JWT
										const payload = { userId, userRoleId, userEmpresasId };

										const token = tokenAuth.generateToken(payload);

										dbConnection.connectionDB.beginTransaction(
											(err) => {
												if (err) {
													globalFunctions.logger(logger_data(req), 'error', `${logger_msg.transaction.error}: ${err}`);
												} else {
													const tokenQuery =
														"UPDATE usuarios SET token = ? WHERE id = ?";
													dbConnection.connectionDB.query(tokenQuery, [token, userId], (error, response) => {
															if (error) {
																dbConnection.connectionDB.rollback(
																	() => {
																		globalFunctions.logger(logger_data(req), 'error', `${logger_msg.query.rollback} tokenQuery: ${err}`);
																	},
																);
															}
															if (response) {
																globalFunctions.logger(logger_data(req), 'info', `${logger_msg.query.response} tokenQuery`);
																dbConnection.connectionDB.commit(
																	(err) => {
																		if (
																			err
																		) {
																			dbConnection.connectionDB.rollback(
																				() => {
																					globalFunctions.logger(logger_data(req), 'error', `${logger_msg.transaction.commitErrorRollback} SP_LoginGetid: ${err}`);
																				},
																			);
																		} else {
																			globalFunctions.logger(logger_data(req), 'info', `${logger_msg.sesionIniciada} ${user.username}`);
																			res.status(200).json({ userId, userRoleId, token, userName },
																			);
																		}
																	},
																);
															}
														},
													);
												}
											},
										);
									}
								}
							},
						);
					} else if (response[0].status != 1) {
						globalFunctions.logger(logger_data(req), 'error', logger_msg.servicio);
						const status = globalFunctions.statusMsg(3);
						// res.status(200).send({ message: "Sin servicio" });
						res.status(200).send(status);
					}
				}
			},
		);
	}
};

loginController.logout_post = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const userId = req.params.idUsuario;
	const tokenQuery = "UPDATE usuarios SET token = '' WHERE id = ?";
	dbConnection.connectionDB.query(tokenQuery, [userId], (error, response) => {
		if (error) {
			globalFunctions.logger(logger_data(req), 'error', logger_msg.errorActualizacionDeToken);
			res.status(200).send({ message: "SQL UPDATE ERROR" });
		}
		if (response) {
			globalFunctions.logger(logger_data(req), 'info', logger_msg.sessionCerrada);
			res.status(200).send(true);
			storage.username = '';
		}
	});
};

module.exports = loginController;