const dbConnection = require("../db/connection");

const fs = require("fs");

require("./globalfuntions.controller");

const { logger_data, logger_msg } = require('../config/utils');

global.__basedir = __dirname;

ordenesComprasController = {};

arrayLog = [];

let ordenesComprasMatrix = [];

let msgLog = [];

//* Carga la página del controlador.
ordenesComprasController.ordenesCompras_loadpage = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
	res.send("API Ordenes Compras");
};

//* Vista de ordenes de compra
ordenesComprasController.ordenesCompras_view = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const empresa = req.body;
	if (!empresa) {
		msgLog.push("No hay información a solicitar.");
		res.status(200).json(msgLog);
		msgLog.length = 0;
	} else if (empresa) {
		console.log("entra :>> ");
		console.log(empresa.id);
		const queryEmpresa = "SELECT nombreComercial FROM empresas WHERE id= ?;";
		dbConnection.connectionDB.query(queryEmpresa, empresa.id, (error, results) => {
			if (error) {
				globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
				throw error;
			} else if (results.length > 0) {
				globalFunctions.logger(logger_data(req), 'info', logger_msg.info);

				const nombreComercial = results[0].nombreComercial;
				const query_vw_comprasOrdenes = "SELECT * FROM vw_comprasOrdenes WHERE idEmpresas= ?;";

				dbConnection.connectionDB.query(query_vw_comprasOrdenes, nombreComercial, (error, results) => {
					if (error) {
						globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
						throw error;
					} else {
						res.json(results);
					}
				});
			} else {
				res.send("Sin resultados");
			}
		});
	}
}

//* Agregar orden de compra
// validacion para cuando no tiene ninguna compraOrdenDetalle pendiente, validacion para la primera creacion de orden compra
ordenesComprasController.ordenesCompras_create_post = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		// Obtener el utlimo ID de comprasOrdenes
		const query = "SELECT CAST(id AS UNSIGNED) + 1 as nuevoID FROM comprasOrdenes WHERE idEmpresas = ? ORDER BY id DESC LIMIT 1;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [data.idEmpresas], (error, response, result) => {
					if (error) {
						dbConnection.connectionDB.rollback(() => {
							console.log("QUERY > ROLLBACK ERROR SELECT (LAST ID +1) comprasOrdenes :>> ", error);
							const status = globalFunctions.statusMsg(0);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						});
					} else if (response) {
						console.log("QUERY RESULT (LAST ID +1) comprasOrdenes :>> ");
						if (response.length == 0) {
							var nuevoID = 1;
						} else {
							var nuevoID = response[0].nuevoID;
						}
						console.log(nuevoID);

						//* Obtener el nuevo correlativo y el documento concatenado.
						const queryCorrelativoID = "SELECT concat_ws('-', serie,correlativo,modulo) AS documento, CAST(correlativo AS UNSIGNED) + 1 AS nuevoCorrelativo " +
							"FROM documentosCorrelativos LEFT JOIN documentos ON documentos.id = documentosCorrelativos.idDocumentos WHERE idDocumentos = 8 AND idUsuarios = ?;";
						dbConnection.connectionDB.query(queryCorrelativoID, [data.idUsuarios], (error, response, result) => {
							var documento = "";
							//var correlativo = "";
							var nuevoCorrelativo = 0;
							if (error) {
								dbConnection.connectionDB.rollback(() => {
									console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
									const status = globalFunctions.statusMsg(0);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else if (response) {
								console.log(response.length);
								if (response.length == 0) {
									console.log("QUERY > ROLLBACK ERROR INSERT comprasOrdenes :>> El usuario no cuenta con documentos correlativos.");

									//!IMPLEMENTAR QUERY PARA CREARLE AL USUARIO UN DOC CORRELATIVO
									const queryPrefijoSerie = "SELECT CONCAT_WS(' ','ORDEN DE COMPRA', roles.descripcion, usuarios.id) AS prefijo, CONCAT_WS(SUBSTRING(roles.descripcion, 1, 1),'OC',usuarios.id) AS serie FROM usuarios "
										+ "LEFT JOIN roles ON usuarios.idRoles = roles.id WHERE usuarios.id = ?;";
									dbConnection.connectionDB.query(queryPrefijoSerie, [data.idUsuarios], (error, response, result) => {
										if (error) {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR SELECT prefijo y serie :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else if (response) {
											const prefijo = response[0].prefijo;
											const serie = response[0].serie;
											//! HACER EL INSERT ACA
											const query = "INSERT INTO documentosCorrelativos (idDocumentos,prefijo,serie,correlativo,idFormatos,idAvailablePrint,idUsuarios,idEmpresas,created_at) VALUES (8,?,?,1,0,1,?,?,CURRENT_TIMESTAMP());";
											dbConnection.connectionDB.query(query, [prefijo, serie, data.idUsuarios, data.idEmpresas], (error, response, result) => {
												if (error) {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT Creación del documento correlativo :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												}
											});
											//! Hacer el SELECT nuevamente para sacar documento y correlativo:
											const queryNuevoCorrelativo = "SELECT concat_ws('-', serie,correlativo,modulo) AS documento, CAST(correlativo AS UNSIGNED) + 1 AS nuevoCorrelativo " +
												" FROM documentosCorrelativos LEFT JOIN documentos ON documentos.id = documentosCorrelativos.idDocumentos WHERE idDocumentos = 8 AND idUsuarios = ?;";
											dbConnection.connectionDB.query(queryNuevoCorrelativo, [data.idUsuarios], (error, response, result) => {
												if (error) {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												} else if (response) {
													console.log("QUERY RESPONSE (NUEVO correlativo +1) :>> ");
													console.log(response);
													documento = response[0].documento;
													//correlativo = response[0].correlativo;
													nuevoCorrelativo = response[0].nuevoCorrelativo;
													// Insertar los encabezados en la tabla de comprasOrdenes.
													//! Campos faltantes ¿?
													const query = "INSERT INTO comprasOrdenes (id,documento,solicitadoPor,idHrmDepartamentos,observaciones," +
														"idTipoOrdenCompra,arribo_at,tipoCambio,idMonedas,monto,idProveedores,status,idUsuarios,idEmpresas) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?);";
													dbConnection.connectionDB.query(query,
														[
															nuevoID,
															documento,
															data.solicitadoPor,
															data.idHrmDepartamentos,
															data.observaciones,
															data.idTipoOrdenCompra,
															data.arribo_at,
															data.tipoCambio,
															data.idMonedas,
															data.monto,
															data.idProveedores,
															1, //Status - Pendiente
															data.idUsuarios,
															data.idEmpresas
														], (error, response, result) => {
															if (error) {
																if (error.code == 'ER_DUP_ENTRY') {
																	dbConnection.connectionDB.rollback(() => {
																		console.log("QUERY > ROLLBACK ERROR INSERT comprasOrdenes :>> ", error);
																		const status = globalFunctions.statusMsg(6);
																		msgLog.length = 0;
																		msgLog.push(status);
																		res.json(msgLog);
																		msgLog.length = 0;
																	});
																} else {
																	dbConnection.connectionDB.rollback(() => {
																		console.log("QUERY > ROLLBACK ERROR INSERT comprasOrdenes :>> ", error);
																		const status = globalFunctions.statusMsg(0);
																		msgLog.length = 0;
																		msgLog.push(status);
																		res.json(msgLog);
																		msgLog.length = 0;
																	});
																}
															} else if (response) {
																console.log("QUERY RESPONSE INSERT comprasOrdenes :>> ");
																console.log(response);

																//* Actualiza el idComprasOrdenes en la tabla de comprasOrdenesDetalle. 
																const query = "UPDATE comprasOrdenesDetalle SET idComprasOrdenes = ? WHERE idComprasOrdenes = 0 AND idUsuarios = ?;";
																dbConnection.connectionDB.query(query,
																	[
																		nuevoID,
																		data.idUsuarios
																		//idEmpresas en la tabla
																	], (error, response, result) => {
																		if (error) {
																			if (error.code == 'ER_DUP_ENTRY') {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenesDetalle :>> ", error);
																					const status = globalFunctions.statusMsg(6);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			} else {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenesDetalle :>> ", error);
																					const status = globalFunctions.statusMsg(0);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			}
																		} else if (response) {
																			console.log("QUERY RESPONSE UPDATE compras detalle :>> ");
																			console.log(response);
																			if (response.affectedRows == 0) {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE productos detalle :>> El usuario no cuenta con ordenes de compra pendientes");
																					const status = globalFunctions.statusMsg(4);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			} else {
																				//console.log("QUERY RESPONSE comprasOrdenesDetalle :>> ");
																				//console.log(response);

																				//* Actualiza el correlativo del usuario. 
																				const query = "UPDATE documentosCorrelativos SET correlativo = ? WHERE idDocumentos = 8 AND idUsuarios = ?;";
																				dbConnection.connectionDB.query(query,
																					[
																						nuevoCorrelativo,
																						data.idUsuarios
																					], (error, response, result) => {
																						if (error) {
																							if (error.code == 'ER_DUP_ENTRY') {
																								dbConnection.connectionDB.rollback(() => {
																									console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																									const status = globalFunctions.statusMsg(6);
																									msgLog.length = 0;
																									msgLog.push(status);
																									res.json(msgLog);
																									msgLog.length = 0;
																								});
																							} else {
																								dbConnection.connectionDB.rollback(() => {
																									console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																									const status = globalFunctions.statusMsg(0);
																									msgLog.length = 0;
																									msgLog.push(status);
																									res.json(msgLog);
																									msgLog.length = 0;
																								});
																							}
																						} else if (response) {
																							console.log("QUERY RESPONSE UPDATE compras detalle :>> ");
																							console.log(response);

																							dbConnection.connectionDB.commit((err) => {
																								if (err) {
																									dbConnection.connectionDB.rollback(() => {
																										console.log(
																											"COMMIT ERROR ROLLBACK INSERT comprasOrdenes :>> ",
																											err,
																										);
																									});
																								} else {
																									const status = globalFunctions.statusMsg(1);
																									msgLog.length = 0;
																									msgLog.push(status);
																									res.json(msgLog);
																									msgLog.length = 0;
																								}
																							});

																							console.log("QUERY RESPONSE INSERT comprasOrdenes :>> ");
																							console.log(response);
																							console.log("Orden de compra cargada correctamente");
																						}
																					});
																			}
																		}
																	}
																);
															}
														});
												}
											});
										}
									});
								} else {
									console.log("QUERY RESPONSE (correlativo +1) :>> ");
									console.log(response);
									documento = response[0].documento;
									nuevoCorrelativo = response[0].nuevoCorrelativo;

									// Insertar los encabezados en la tabla de comprasOrdenes.
									//! Campos faltantes ¿?
									const query = "INSERT INTO comprasOrdenes (id,documento,solicitadoPor,idHrmDepartamentos,observaciones," +
										"idTipoOrdenCompra,arribo_at,tipoCambio,idMonedas,monto,idProveedores,status,idUsuarios,idEmpresas) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?);";
									dbConnection.connectionDB.query(query,
										[
											nuevoID,
											documento,
											data.solicitadoPor,
											data.idHrmDepartamentos,
											data.observaciones,
											data.idTipoOrdenCompra,
											data.arribo_at,
											data.tipoCambio,
											data.idMonedas,
											data.monto,
											data.idProveedores,
											1, //Status - Pendiente
											data.idUsuarios,
											data.idEmpresas
										], (error, response, result) => {
											if (error) {
												if (error.code == 'ER_DUP_ENTRY') {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT comprasOrdenes :>> ", error);
														const status = globalFunctions.statusMsg(6);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												} else {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT comprasOrdenes :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												}
											} else if (response) {
												console.log("QUERY RESPONSE INSERT comprasOrdenes :>> ");
												console.log(response);

												//* Actualiza el idComprasOrdenes en la tabla de comprasOrdenesDetalle. 
												const query = "UPDATE comprasOrdenesDetalle SET idComprasOrdenes = ? WHERE idComprasOrdenes = 0 AND idUsuarios = ?;";
												dbConnection.connectionDB.query(query,
													[
														nuevoID,
														data.idUsuarios
														//idEmpresas en la tabla
													], (error, response, result) => {
														if (error) {
															if (error.code == 'ER_DUP_ENTRY') {
																dbConnection.connectionDB.rollback(() => {
																	console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenesDetalle :>> ", error);
																	const status = globalFunctions.statusMsg(6);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															} else {
																dbConnection.connectionDB.rollback(() => {
																	console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenesDetalle :>> ", error);
																	const status = globalFunctions.statusMsg(0);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															}
														} else if (response) {
															console.log("QUERY RESPONSE UPDATE compras detalle :>> ");
															console.log(response);
															if (response.affectedRows == 0) {
																dbConnection.connectionDB.rollback(() => {
																	console.log("QUERY > ROLLBACK ERROR UPDATE productos detalle :>> El usuario no cuenta con ordenes de compra pendientes");
																	const status = globalFunctions.statusMsg(4);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															} else {
																//console.log("QUERY RESPONSE comprasOrdenesDetalle :>> ");
																//console.log(response);

																//* Actualiza el correlativo del usuario. 
																const query = "UPDATE documentosCorrelativos SET correlativo = ? WHERE idDocumentos = 8 AND idUsuarios = ?;";
																dbConnection.connectionDB.query(query,
																	[
																		nuevoCorrelativo,
																		data.idUsuarios
																	], (error, response, result) => {
																		if (error) {
																			if (error.code == 'ER_DUP_ENTRY') {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																					const status = globalFunctions.statusMsg(6);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			} else {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																					const status = globalFunctions.statusMsg(0);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			}
																		} else if (response) {
																			console.log("QUERY RESPONSE UPDATE compras detalle :>> ");
																			console.log(response);

																			dbConnection.connectionDB.commit((err) => {
																				if (err) {
																					dbConnection.connectionDB.rollback(() => {
																						console.log(
																							"COMMIT ERROR ROLLBACK INSERT comprasOrdenes :>> ",
																							err,
																						);
																					});
																				} else {
																					const status = globalFunctions.statusMsg(1);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				}
																			});

																			console.log("QUERY RESPONSE INSERT comprasOrdenes :>> ");
																			console.log(response);
																			console.log("Orden de compra cargada correctamente");


																		}
																	});
															}
														}
													}
												);
											}
										});
								}
							}
						});
					}
				});
			}
		});
	}
}

//* Agregar un producto a la orden de compra
ordenesComprasController.ordenesCompras_create_detalle_post = (req, res) => {
	const data = req.body;
	console.table(data);
	const query = "INSERT INTO comprasOrdenesDetalle (idComprasOrdenes,idProductos,cantidad,precio,total,idUsuarios) VALUES (0,?,?,?,?,?);";
	dbConnection.connectionDB.beginTransaction((err) => {
		if (err) {
			console.error("TRANSACTION ERROR :>> ", err);
		} else {
			dbConnection.connectionDB.query(
				query,
				[
					data.idProductos,
					data.cantidad,
					data.precio,
					data.total,
					data.idUsuarios
				],
				(error, response, result) => {
					if (error) {
						dbConnection.connectionDB.rollback(() => {
							console.log("QUERY > ROLLBACK ERROR INSERT comprasOrdenesDetalle :>> ", error);
							const status = globalFunctions.statusMsg(0);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						});
					} else if (response) {
						const query = "UPDATE productos SET precioCosto = ?, margen = ?, precioPublico = ? WHERE id = ?;";
						dbConnection.connectionDB.query(query,
							[
								data.precioCosto,
								data.margen,
								data.precioPublico,
								data.idProductos,
								data.idEmpresas

							], (error, response, result) => {
								if (error) {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else if (response) {
									console.log(response);
									dbConnection.connectionDB.commit((err) => {
										if (err) {
											dbConnection.connectionDB.rollback(() => {
												console.log(
													"COMMIT ERROR ROLLBACK INSERT comprasOrdenesDetalle :>> ",
													err,
												);
											});
										} else {
											console.log("QUERY RESPONSE :>> ");
											console.log(response);
											const status = globalFunctions.statusMsg(1);
											msgLog.length = 0;
											msgLog.push(status);
											res.json(msgLog);
											msgLog.length = 0;
										}
									});
								}
							}
						);
					}
				},
			);
		}
	});
};

//* Datos de comprasOrdenes especifica 
ordenesComprasController.ordenesCompras_detail = (req, res) => {
	const data = req.body;
	console.table(data);
	const query = "SELECT * FROM comprasOrdenes WHERE id = ?;";
	dbConnection.connectionDB.query(query, [data.id], (error, results, response) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

//* Datos de comprasOrdenesDetalle carrito 
ordenesComprasController.ordenesCompras_detail_cart = (req, res) => {
	const data = req.body;
	console.table(data);
	const query = "SELECT comprasOrdenesDetalle.id,productos.descLarga,idProductos,comprasOrdenesDetalle.cantidad,comprasOrdenesDetalle.precio," +
		"comprasOrdenesDetalle.total,idUsuarios, productos.precioCosto, productos.precioPublico, productos.margen  FROM comprasOrdenesDetalle " +
		"LEFT JOIN productos ON productos.id = idProductos WHERE idComprasOrdenes = 0 and idUsuarios = ?;";
	dbConnection.connectionDB.query(query, [data.idUsuarios], (error, results, response) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

//* Datos de comprasOrdenesDetalle especifica
//! Se envia la id recuperada de la orden de compra
ordenesComprasController.ordenesCompras_detalle_list = (req, res) => {
	const data = req.body;
	console.table(data);
	const query = "SELECT comprasOrdenesDetalle.id,idComprasOrdenes,productos.descLarga,idProductos,comprasOrdenesDetalle.cantidad,comprasOrdenesDetalle.precio," +
		"comprasOrdenesDetalle.total,idUsuarios,idTipoProductos, productos.precioCosto, productos.precioPublico, productos.margen FROM comprasOrdenesDetalle " +
		"LEFT JOIN productos ON productos.id = idProductos WHERE idComprasOrdenes = ? and idUsuarios = ?;";
	dbConnection.connectionDB.query(query, [data.id, data.idUsuarios], (error, results, response) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

//* Update para comprasOrdenes (headers)
ordenesComprasController.ordenesCompras_update_post = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		const query = "UPDATE comprasOrdenes SET observaciones = ?, idTipoOrdenCompra = ?, idMonedas = ?, monto = ?, tipoCambio = ? WHERE id = ? AND idEmpresas = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						data.observaciones,
						data.idTipoOrdenCompra,
						data.idMonedas,
						data.monto,
						data.tipoCambio,
						data.id,
						data.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenes :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK UPDATE comprasOrdenes :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
				);
			}
		});
	}
}

//* Update para el estado de una orden de compra - Gestión de una orden de compra, si se aprobó, rechazó y motivo.
ordenesComprasController.ordenesCompras_update_status_post = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		const query = "UPDATE comprasOrdenes SET status = ?,  idAdminUser = ?, observacionesAuth = ?, auth_at = CURRENT_TIMESTAMP() WHERE id = ? AND idEmpresas = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						data.status,
						data.idAdminUser,
						data.observacionesAuth,
						data.id,
						data.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenes :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK UPDATE comprasOrdenes :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
				);
			}
		});
	}
}

//* Eliminacion de una orden de compra.
ordenesComprasController.ordenesCompras_delete = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		const query = "DELETE FROM comprasOrdenes WHERE id = ?;"; //idEmpresas
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [data.id],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' comprasOrdenes :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							const query = "DELETE FROM comprasOrdenesDetalle WHERE idComprasOrdenes = ? AND idUsuarios = ?;";
							dbConnection.connectionDB.query(query, [data.id, data.idUsuarios], (error, response, result) => {
								if (error) {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR DELETE comprasOrdenesDetalle :>> ", error);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else if (response) {
									console.log("QUERY RESPONSE DELETE comprasOrdenesDetalle :>> ");
									console.log(response);
									dbConnection.connectionDB.commit((err) => {
										if (err) {
											dbConnection.connectionDB.rollback(() => {
												console.log(
													"COMMIT ERROR ROLLBACK DELETE comprasOrdenesDetalle :>> ",
													err,
												);
											});
										} else {
											const status = globalFunctions.statusMsg(1);
											msgLog.length = 0;
											msgLog.push(status);
											res.json(msgLog);
											msgLog.length = 0;
										}
									});
									console.log("QUERY RESPONSE DELETE comprasOrdenesDetalle :>> ");
									console.log(response);
									console.log("Eliminacion realizada correctamente");
								}
							});
						}
					},
				);
			}
		});
	}
};

//* Update para comprasOrdenesDetalle (details)
ordenesComprasController.ordenesCompras_update_detail_post = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		const query = "UPDATE comprasOrdenesDetalle SET cantidad = ?, precio = ?, total = ? WHERE id = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						data.cantidad,
						data.precio,
						data.total,
						data.id,
						//data.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenesDetalle :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);

							//! ACTUALIZAR AQUI TAMBIEN LOS DATOS EN LA TABLA DE PRODUCTOS 
							const query = "UPDATE productos SET precioCosto = ?, margen = ?, precioPublico = ? WHERE id = ? AND idEmpresas = ?;";
							dbConnection.connectionDB.query(query,
								[
									data.precioCosto,
									data.margen,
									data.precioPublico,
									data.idProductos,
									data.idEmpresas

								], (error, response, result) => {
									if (error) {
										if (error.code == 'ER_DUP_ENTRY') {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
												const status = globalFunctions.statusMsg(6);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										}
									} else if (response) {
										dbConnection.connectionDB.commit((err) => {
											if (err) {
												dbConnection.connectionDB.rollback(() => {
													console.log(
														"COMMIT ERROR ROLLBACK UPDATE comprasOrdenesDetalle :>> ",
														err,
													);
												});
											} else {
												console.log("QUERY RESPONSE :>> ");
												console.log(response);
												const status = globalFunctions.statusMsg(1);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											}
										});
									}
								}
							);
						}
					},
				);
			}
		});
	}
}

//* Agregar un producto a orden de compras existente
ordenesComprasController.ordenesCompras_add_detalle_post = (req, res) => {
	const data = req.body;
	console.log('sexo anal')
	console.table(data);
	const query = "INSERT INTO comprasOrdenesDetalle (idComprasOrdenes,idProductos,cantidad,precio,total,idUsuarios) VALUES (?,?,?,?,?,?);";
	dbConnection.connectionDB.beginTransaction((err) => {
		if (err) {
			console.error("TRANSACTION ERROR :>> ", err);
		} else {
			dbConnection.connectionDB.query(
				query,
				[
					data.idComprasOrdenes,
					data.idProductos, //idProducto
					data.cantidad,
					data.precio,
					data.total,
					data.idUsuarios
				],
				(error, response, result) => {
					if (error) {
						dbConnection.connectionDB.rollback(() => {
							console.log("QUERY > ROLLBACK ERROR INSERT comprasOrdenesDetalle :>> ", error);
							const status = globalFunctions.statusMsg(0);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						});
					} else if (response) {
						//! ACTUALIZAR precioPublico, precioCosto, margen EN TABLA PRODUCTOS...
						const query = "UPDATE productos SET precioCosto = ?, margen = ?, precioPublico = ? WHERE id = ? AND idEmpresas = ?;";
						dbConnection.connectionDB.query(query,
							[
								data.precioCosto,
								data.margen,
								data.precioPublico,
								data.idProductos,
								data.idEmpresas

							], (error, response, result) => {
								if (error) {
									if (error.code == 'ER_DUP_ENTRY') {
										dbConnection.connectionDB.rollback(() => {
											console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
											const status = globalFunctions.statusMsg(6);
											msgLog.length = 0;
											msgLog.push(status);
											res.json(msgLog);
											msgLog.length = 0;
										});
									} else {
										dbConnection.connectionDB.rollback(() => {
											console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
											const status = globalFunctions.statusMsg(0);
											msgLog.length = 0;
											msgLog.push(status);
											res.json(msgLog);
											msgLog.length = 0;
										});
									}
								} else if (response) {
									const query = "UPDATE comprasOrdenes SET monto=? WHERE id=? AND idEmpresas=?;";
									dbConnection.connectionDB.query(query,
										[
											data.monto,
											data.idComprasOrdenes,
											data.idEmpresas
										], (error, response, result) => {
											if (error) {
												dbConnection.connectionDB.rollback(() => {
													console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenes monto :>> ", error);
													const status = globalFunctions.statusMsg(0);
													msgLog.length = 0;
													msgLog.push(status);
													res.json(msgLog);
													msgLog.length = 0;
												});
											} else if (response) {
												dbConnection.connectionDB.commit((err) => {
													if (err) {
														dbConnection.connectionDB.rollback(() => {
															console.log(
																"COMMIT ERROR ROLLBACK INSERT comprasOrdenesDetalle :>> ",
																err,
															);
														});
													} else {
														console.log("QUERY RESPONSE :>> ");
														console.log(response);
														const status = globalFunctions.statusMsg(1);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													}
												});
											}
										}
									);
									// dbConnection.connectionDB.commit((err) => {
									// 	if (err) {
									// 		dbConnection.connectionDB.rollback(() => {
									// 			console.log(
									// 				"COMMIT ERROR ROLLBACK INSERT comprasOrdenesDetalle :>> ",
									// 				err,
									// 			);
									// 		});
									// 	} else {
									// 		console.log("QUERY RESPONSE :>> ");
									// 		console.log(response);
									// 		const status = globalFunctions.statusMsg(1);
									// 		msgLog.length = 0;
									// 		msgLog.push(status);
									// 		res.json(msgLog);
									// 		msgLog.length = 0;
									// 	}
									// });
								}
							}
						);
					}
				}
			);
		}
	});
};

//* Eliminacion de un producto en orden de compra detalle
ordenesComprasController.ordenesCompras_delete_detalle = (req, res) => {
	const data = req.body;
	console.log(data)
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		// DELETE FROM comprasOrdenesDetalle WHERE idCompras = 0 AND idProductos = ? AND idUsuarios = ?;
		const query = "DELETE FROM comprasOrdenesDetalle WHERE id = ? AND idUsuarios = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [data.id, data.idUsuarios],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' comprasOrdenesDetalle :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							if (response.affectedRows == 0) {
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"COMMIT ERROR ROLLBACK 'DELETE' comprasOrdenesDetalle :>> No se encontraron resultados "
									);
									const status = globalFunctions.statusMsg(4);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else {
								//* Ir a eliminar a la tabla de comprasDetalle
								const query = "DELETE FROM comprasDetalle WHERE idCompras = 0 AND idComprasOrdenes = ? AND idProductos = ? AND idUsuarios = ?;";
								dbConnection.connectionDB.query(query,
									[
										data.idComprasOrdenes,
										data.idProductos,
										data.idUsuarios
									],
									(error, response, result) => {
										if (error) {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR DELETE comprasDetalle :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else if (response) {

											const query = "UPDATE comprasOrdenes SET monto=? WHERE id=? AND idEmpresas=?;";
											dbConnection.connectionDB.query(query,
												[
													data.monto,
													data.idComprasOrdenes,
													data.idEmpresas
												], (error, response, result) => {
													if (error) {
														dbConnection.connectionDB.rollback(() => {
															console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenes monto :>> ", error);
															const status = globalFunctions.statusMsg(0);
															msgLog.length = 0;
															msgLog.push(status);
															res.json(msgLog);
															msgLog.length = 0;
														});
													} else if (response) {
														dbConnection.connectionDB.commit((err) => {
															if (err) {
																dbConnection.connectionDB.rollback(() => {
																	console.log(
																		"COMMIT ERROR ROLLBACK 'DELETE' comprasOrdenesDetalle :>> ",
																		err,
																	);
																	const status = globalFunctions.statusMsg(0);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															} else {
																console.log("comprasOrdenesDetalle eliminada con exito");
																const status = globalFunctions.statusMsg(1);
																msgLog.length = 0;
																msgLog.push(status);
																res.json(msgLog);
																msgLog.length = 0;
															}
														});
													}
												}
											);

										}
									});
							}
						}
					},
				);
			}
		});
	}
};

//! Cuando se realiza una compra que uso una orden de compra, se actualizará su registro en la tabla comprasOrdenes (idCompra).
//* Update para asignarle un idCompras a la orden de compra si esta se uso para una compra.
ordenesComprasController.ordenesCompras_update_idCompras = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		//* Obtener el ultimo ID de compras correspondiente al usuario para asignarlo a comprasOrdenes
		const query = "SELECT * FROM compras WHERE idUsuarios = ? and idEmpresas = ? ORDER BY id DESC LIMIT 1;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						data.idUsuarios,
						data.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR SELECT comprasOrdenes idCompras :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT SELECT ULTIMO id de COMPRAS:>> ");
							console.log(response);

							if (response.length == 0) {
								dbConnection.connectionDB.rollback(() => {
									console.log("QUERY > ROLLBACK ERROR SELECT ULTIMO id de COMPRAS :>> No hay resultados a mostrar");
									const status = globalFunctions.statusMsg(4);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else {
								const idCompras = response[0].id;
								//* Actualizar el idCompras 
								const query = "UPDATE comprasOrdenes SET idCompras = ?, status = 4 WHERE id = ? AND idEmpresas = ?;";
								dbConnection.connectionDB.query(query,
									[
										idCompras,
										data.id, //id de la orden de compra que se obtuvo filtando su status.
										data.idEmpresas
									],
									(error, response, result) => {
										if (error) {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else if (response) {
											dbConnection.connectionDB.commit((err) => {
												if (err) {
													dbConnection.connectionDB.rollback(() => {
														console.log(
															"COMMIT ERROR ROLLBACK UPDATE comprasOrdenes idCompras :>> ",
															err,
														);
													});
												} else {
													const status = globalFunctions.statusMsg(1);
													msgLog.length = 0;
													msgLog.push(status);
													res.json(msgLog);
													msgLog.length = 0;
												}
											});
										}
									});

							}

						}
					},
				);
			}
		});
	}
}

module.exports.ordenesComprasController = ordenesComprasController;