const dbConnection = require("../db/connection");

// const readXlsxFile = require("read-excel-file/node");

const fs = require("fs");

const XLSX = require("xlsx");

const globalFun = require("./globalfuntions.controller");

const { logger_data, logger_msg } = require('../config/utils');

global.__basedir = __dirname;

productos_codigos_alternosController = {};

let msgLog = [];

productos_codigos_alternosController.loadpage = (req, res) => {
    res.send("API productos Codigos Alternos");
}

productos_codigos_alternosController.productos_codigos_alternos_list = (req, res) => {
    const query = "SELECT * FROM productosCodigosAlternos";
    dbConnection.connectionDB.query(query, (error, results) => {
        if (error) {
            globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
            throw error;
        } else if (results.length > 0) {
            globalFunctions.logger(logger_data(req), 'info', logger_msg.info);
            res.json(results);
        } else {
            const status = globalFunctions.statusMsg(4);
            globalFunctions.logger(logger_data(req), 'error', status.status_message_description);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        }
    });
};

productos_codigos_alternosController.productos_codigos_alternos_detail = (req, res) => {
    globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
    const productoCA = req.body;
    const query = "SELECT * FROM productosCodigosAlternos WHERE idProductos = ? AND idEmpresas = ?;";
    dbConnection.connectionDB.query(query, [productoCA.idProductos, productoCA.idEmpresas], (error, results) => {
        if (error) {
            globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
            const status = globalFunctions.statusMsg(0);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else if (results.length > 0) {
            res.json(results);
        } else {
            const status = globalFunctions.statusMsg(4);
            console.table(status);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        }
    });
};

productos_codigos_alternosController.productos_codigos_alternos_create_post = (req, res) => {
    globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
    const productoCA = req.body;
    const query = "INSERT INTO productosCodigosAlternos (idProductos, sku, idEmpresas, created_at) VALUES(?, ?, ?, CURRENT_TIMESTAMP());";

    if (!productoCA) {
        const status = globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {

        if (!productoCA.idProductos ||
            !productoCA.sku ||
            !productoCA.idEmpresas) {
            const status = globalFunctions.statusMsg(4);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else {
            dbConnection.connectionDB.beginTransaction((err) => {
                if (err) {
                    console.error("TRANSACTION ERROR :>> ", err);
                } else {
                    dbConnection.connectionDB.query(
                        query, [productoCA.idProductos, productoCA.sku, productoCA.idEmpresas],
                        (error, response, result) => {
                            if (error) {
                                if (error.code == 'ER_DUP_ENTRY') {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log("QUERY > ROLLBACK ERROR INSERT productoCA :>> ", error);
                                        const status = globalFunctions.statusMsg(6);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                } else {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log("QUERY > ROLLBACK ERROR INSERT productoCA :>> ", error);
                                        const status = globalFunctions.statusMsg(0);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                }

                            } else if (response) {
                                console.log("QUERY RESULT :>> ");
                                console.log(result);
                                dbConnection.connectionDB.commit((err) => {
                                    if (err) {
                                        dbConnection.connectionDB.rollback(() => {
                                            console.log(
                                                "COMMIT ERROR ROLLBACK INSERT productoCA :>> ",
                                                err,
                                            );
                                        });
                                    } else {
                                        const status = globalFunctions.statusMsg(1);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    }
                                });
                            }
                        },
                    );
                }
            });
        }
    }
}

productos_codigos_alternosController.productos_codigos_alternos_update_post = (req, res) => {
    globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
    const productoCA = req.body;
    const query = "UPDATE productosCodigosAlternos SET sku=?, updated_at=CURRENT_TIMESTAMP() WHERE id=? AND idEmpresas=?;";

    if (!productoCA) {
        const status = globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {

        if (
            !productoCA.sku ||
            !productoCA.id ||
            !productoCA.idEmpresas) {
            const status = globalFunctions.statusMsg(4);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else {
            dbConnection.connectionDB.beginTransaction((err) => {
                if (err) {
                    console.error("TRANSACTION ERROR :>> ", err);
                } else {
                    dbConnection.connectionDB.query(
                        query, [productoCA.sku, productoCA.id, productoCA.idEmpresas],
                        (error, response, result) => {
                            if (error) {
                                if (error.code == 'ER_DUP_ENTRY') {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log("QUERY > ROLLBACK ERROR INSERT productoCA :>> ", error);
                                        const status = globalFunctions.statusMsg(6);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                } else {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log("QUERY > ROLLBACK ERROR INSERT productoCA :>> ", error);
                                        const status = globalFunctions.statusMsg(0);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                }

                            } else if (response) {
                                console.log("QUERY RESULT :>> ");
                                console.log(result);
                                dbConnection.connectionDB.commit((err) => {
                                    if (err) {
                                        dbConnection.connectionDB.rollback(() => {
                                            console.log(
                                                "COMMIT ERROR ROLLBACK INSERT productoCA :>> ",
                                                err,
                                            );
                                        });
                                    } else {
                                        const status = globalFunctions.statusMsg(1);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    }
                                });
                            }
                        },
                    );
                }
            });
        }
    }
}

productos_codigos_alternosController.productos_codigos_alternos_delete_post = (req, res) => {
    globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
    const productoCA = req.body;
    const query = "DELETE FROM productosCodigosAlternos WHERE id = ? AND idEmpresas = ?";

    if (!productoCA) {
        const status = globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {

        if (!productoCA.id ||
            !productoCA.idEmpresas) {
            const status = globalFunctions.statusMsg(4);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else {
            dbConnection.connectionDB.beginTransaction((err) => {
                if (err) {
                    console.error("TRANSACTION ERROR :>> ", err);
                } else {
                    dbConnection.connectionDB.query(
                        query, [productoCA.id, productoCA.idEmpresas],
                        (error, response, result) => {
                            if (error) {
                                if (error.code == 'ER_DUP_ENTRY') {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log("QUERY > ROLLBACK ERROR INSERT productoCA :>> ", error);
                                        const status = globalFunctions.statusMsg(6);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                } else {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log("QUERY > ROLLBACK ERROR INSERT productoCA :>> ", error);
                                        const status = globalFunctions.statusMsg(0);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                }

                            } else if (response) {
                                console.log("QUERY RESULT :>> ");
                                console.log(result);
                                dbConnection.connectionDB.commit((err) => {
                                    if (err) {
                                        dbConnection.connectionDB.rollback(() => {
                                            console.log(
                                                "COMMIT ERROR ROLLBACK INSERT productoCA :>> ",
                                                err,
                                            );
                                        });
                                    } else {
                                        const status = globalFunctions.statusMsg(1);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    }
                                });
                            }
                        },
                    );
                }
            });
        }
    }
}

module.exports.productos_codigos_alternosController = productos_codigos_alternosController;