const { Router } = require("express");
const express = require("express");
const router = Router();

const path = require("path");
const bodyParser = require("body-parser");

const loginRoute = require("./login.route");
const empresasRoute = require('./empresas.route');
const empresaConfigRoute = require("./empresaconfig.route");

const nomenclaturasRoute = require("./nomenclaturas.route");
const centrosCostoRoute = require("./centroscosto.route");
const clientesRoute = require("./clientes.route");
const medidasRoute = require("./medidas.route");
const productosRoute = require("./productos.route");

const reportesRoute = require("./reportes.route");
const archivosExtensionesRoute = require("./archivos_extensiones.route");

const usuariosRoute = require("./usuarios.route");
const rolesRoute = require("./roles.route");
const sucursalesRoute = require("./sucursales.route");
const status_empleadoRoute = require("./status_empleado.route");

const tipoProductosRoute = require("./tipo_productos.route");
const marcasRoute = require("./marcas.route");
const familiaNivel1Route = require("./familia_nivel_1.route");
const familiaNivel2Route = require("./familia_nivel_2.route");
const familiaNivel3Route = require("./familia_nivel_3.route");
const gruposRoute = require("./grupos.route");
const pcaRoute = require("./productos_codigos_alternos.route");
const pcRoute = require("./productos_componentes.route");
const precioMoneda = require("./precio_moneda.route");

const ajustesRoute = require("./ajustes.route");

const comprasRoute = require("./compras.route");
const ordenesComprasRoute = require("./ordenes_compras.route");

const monedasRoute = require("./monedas.route")
const hrmDepartamentos = require('./hrmDepartamentos.route');

const opcionesProductoRoute = require("./opciones_producto.route");
const opcionProductoRoute = require("./opcion_producto.route");
const menuOptionsRoute = require("./menu_options.route");

const proveedoresRoute = require("./proveedores.route");
const bodegasSucursalesRoute = require("./bodegas_sucursales.route");

const kardexRoute = require("./kardex.route");
const bancosRoute = require("./bancos.route");

const documentosCorrelativos = require("./documentos_correlativos.route");

const tokenAuth = require("../middleware/token.auth");

router.use(bodyParser.json());
router.use(
    bodyParser.urlencoded({
        extended: true,
    }),
);

router.use("/api/login", loginRoute);

router.use("/api/empresas", [tokenAuth.verifyToken], empresasRoute);
router.use("/api/empresaConfig", empresaConfigRoute);

router.use("/api/documentos/nomenclaturas", [tokenAuth.verifyToken], nomenclaturasRoute);
router.use("/api/documentos/centroscosto", [tokenAuth.verifyToken], centrosCostoRoute);
router.use("/api/documentos/clientes", [tokenAuth.verifyToken], clientesRoute);
router.use("/api/documentos/medidas", [tokenAuth.verifyToken], medidasRoute);
router.use("/api/documentos/productos", [tokenAuth.verifyToken], productosRoute);

router.use("/api/reportes", [tokenAuth.verifyToken], reportesRoute);
router.use("/api/archivos-extensiones", archivosExtensionesRoute);

router.use("/api/ajustes", ajustesRoute);
router.use("/api/compras", comprasRoute);

router.use("/api/compras/ordenes-compras", ordenesComprasRoute);
router.use("/api/monedas", monedasRoute);
router.use("/api/hrmDepartamentos", hrmDepartamentos);

router.use("/api/opciones_producto", opcionesProductoRoute);
router.use("/api/opcion_producto", opcionProductoRoute);
router.use("/api/menu_options", menuOptionsRoute);

router.use("/api/administracion/proveedores", proveedoresRoute);
router.use("/api/administracion/bodegas-sucursales", bodegasSucursalesRoute);

router.use("/api/kardex", kardexRoute);
router.use("/api/bancos", bancosRoute);

router.use("/api/administracion/usuarios", [tokenAuth.verifyToken], usuariosRoute);
router.use("/api/administracion/roles", [tokenAuth.verifyToken], rolesRoute);
router.use("/api/administracion/sucursales", [tokenAuth.verifyToken], sucursalesRoute);
router.use("/api/administracion/status_empleado", [tokenAuth.verifyToken], status_empleadoRoute);
router.use("/api/administracion/clientes", [tokenAuth.verifyToken], clientesRoute);

router.use("/api/tipo_productos", [tokenAuth.verifyToken], tipoProductosRoute);
router.use("/api/marcas", [tokenAuth.verifyToken], marcasRoute);
router.use("/api/familia_nivel_1", [tokenAuth.verifyToken], familiaNivel1Route);
router.use("/api/familia_nivel_2", [tokenAuth.verifyToken], familiaNivel2Route);
router.use("/api/familia_nivel_3", [tokenAuth.verifyToken], familiaNivel3Route);
router.use("/api/grupos", [tokenAuth.verifyToken], gruposRoute);
router.use("/api/productos_codigos_alternos", [tokenAuth.verifyToken], pcaRoute);
router.use("/api/productos_componentes", [tokenAuth.verifyToken], pcRoute);
router.use("/api/precio_moneda", precioMoneda);
router.use("/api/documentos-correlativos", documentosCorrelativos);

module.exports = router;